enum STATUS_IGRE
{
	U_TOKU,
	POBEDIO_X,
	POBEDIO_O,
	NERESENO
}

public class XO 
{

	int[][] polja = new int[3][3];
	int naPotezu; 
	STATUS_IGRE statusIgre;
	int brojOdigranihPoteza;
	
	public XO()
	{
		inicijalizuj();
	}
	
	public void inicijalizuj()
	{
		naPotezu = 1;
		statusIgre = STATUS_IGRE.U_TOKU;
		brojOdigranihPoteza = 0;
		
		for (int i = 0; i < polja.length; i++) {
			for (int j = 0; j < polja.length; j++) {
				polja[i][j] = 0;
			}
		}
	}
	
	public STATUS_IGRE odigrajPotez(int i, int j)
	{
		STATUS_IGRE status = STATUS_IGRE.U_TOKU;
		
		if(polja[i][j] == 0)
		{
			brojOdigranihPoteza++;
			polja[i][j] = naPotezu;
			naPotezu *= -1;
			status = provera();
		}
		
		statusIgre = status;
		
		//System.out.println(toString());
		
		return status;
	}
	
	public STATUS_IGRE provera() 
	{
		int suma = 0;
		STATUS_IGRE status = STATUS_IGRE.U_TOKU;
		
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				suma += polja[i][j];
			}
			
			if(suma == 3) {
				status = STATUS_IGRE.POBEDIO_X;
				return status;
			}
			else if(suma == -3) {
				status = STATUS_IGRE.POBEDIO_O;
				return status;
			}
			else suma = 0;
		}
		
		for (int j = 0; j < 3; j++) {
			for (int i = 0; i < 3; i++) {
				suma += polja[i][j];
			}
			
			if(suma == 3) {
				status = STATUS_IGRE.POBEDIO_X;
				return status;
			}
			else if(suma == -3) {
				status = STATUS_IGRE.POBEDIO_O;
				return status;
			}
			else suma = 0;
		}
		
		suma += polja[0][0] + polja[1][1] + polja[2][2];
		if(suma == 3) {
			status = STATUS_IGRE.POBEDIO_X;
			return status;
		}
		else if(suma == -3) {
			status = STATUS_IGRE.POBEDIO_O;
			return status;
		}
		else suma = 0;
		
		suma += polja[0][2] + polja[1][1] + polja[2][0];
		if(suma == 3) {
			status = STATUS_IGRE.POBEDIO_X;
			return status;
		}
		else if(suma == -3) {
			status = STATUS_IGRE.POBEDIO_O;
			return status;
		}
		else suma = 0;
				
		
		if(brojOdigranihPoteza == 9)
			status = STATUS_IGRE.NERESENO;
			
		return status;
	}

	@Override
	public String toString() {
		
		String polja = "";
		
		if(statusIgre == STATUS_IGRE.NERESENO)
			polja += "Igra je neresena!\n";
		else 
			polja += "Na potezu je: " + koJeNaPotezu() + "\n";
		
		for (int i = 0; i < this.polja.length; i++) {
			polja += "\n";
			for (int j = 0; j < this.polja.length; j++) {
				polja += dajOznakuPolja(i, j);
			}
		}
		
		polja += "\n------------------------";
		
		return polja;
	}

	public String dajOznakuPolja(int i, int j) {
		
		if(polja[i][j] == 1)
			return " X ";
		else if(polja[i][j] == -1)
			return " O ";
		else return " - ";
	}

	public String koJeNaPotezu() {
		if(naPotezu == 1)
			return "X";
		else //if (naPotezu == -1)
			return "O";

	}
}
